<?php

/**
* Plugin Name: BWL Knowledge Base Manager
* Plugin URI: http://bit.ly/bwl-knowledge-base
* Description: Knowledge Base Manager plugin comes with lots of unique and flexible features to create unlimited number of Knowledge Base question and answers for your website content. Sticky and shortcode base Ajax search options give your user best experiences to find there required asnwers. It has an awesome shortcode editor that provide you all kinds of options to insert shortcode in tinymce editor. Built-in widgets display latest/top up voted/top down voted/popular knowledge base in sidebar area.  2.0.S.C.R.I.P.T.i.r
* Author: 20 Script
* Version: 1.1.2
* Author URI: http://www.20script.ir
* WP Requires at least: 3.6+
* Text Domain: bwl-kb
*/

// If this file is called directly, abort.
if ( ! defined( 'WPINC' ) ) {
    die;
}

if ( !class_exists( 'BWL_KB_Manager' ) ) {

    Class BWL_KB_Manager{

        function __construct() {

            //Include For Multisite Network Checking
            //@Introduced In Version 1.1.1

            include_once( ABSPATH . 'wp-admin/includes/plugin.php' );

            GLOBAL $bkb_data;

            $bkb_data = get_option('bkb_options');

             /*------------------------------ PLUGIN COMMON CONSTANTS ---------------------------------*/
            define( "BWL_KB_PLUGIN_TITLE", 'BWL Knowledge Base Manager');
            define( "BWL_KB_PLUGIN_DIR", plugins_url() .'/bwl-kb-manager/' );
            define( "BWL_KB_PLUGIN_VERSION", '1.1.2');
            define( "BWL_KB_PLUGIN_PRODUCTION_STATUS", 1);
            define( "PREFIX_BKB_CAT", 'bkb_cat_'); // Required for custom sorting addon.
            define( "PREFIX_BKB_TAG", 'baf_tag_'); // Required for custom sorting addon.
            $this->register_post_type();
            $this->taxonomies();     
            $this->included_files();
            $this->enqueue_plugin_scripts();
            $this->bkb_version_manager(BWL_KB_PLUGIN_VERSION);
            $this->bkb_cau();

            //@Description: Load Only Admin Scripts.
            //@Since: 1.0.9
            add_action('admin_enqueue_scripts', array( $this, 'bkbm_admin_load_scripts' ));

            // Introduced in version 1.0.9
            add_filter( 'pre_get_posts', array( $this, 'bkbm_taxonomy_filters' ) );

        }

        // @Description: Store Plugin Version in Database
        // @Since: version 1.0.1

        function bkb_version_manager($latest_version) {

            $current_version = get_option('bwl_kb_plugin_version');

            if( $current_version == "" ) {

                update_option('bwl_kb_plugin_version', $latest_version);

            } elseif( $current_version != $latest_version ) {

                update_option('bwl_kb_plugin_version', $latest_version);

            } else {
                // Do nothing!
            }


        }


        // @Description: Plugin required PHP files.
        // @Since: version 1.0.1

        function included_files() {

            include_once dirname(__FILE__) . '/includes/bkb-helpers.php'; 
            include_once dirname(__FILE__) . '/includes/bkb-ajax-search.php'; 
            include_once dirname(__FILE__) . '/includes/bkb-single-post-functions.php'; 
            include_once dirname(__FILE__) . '/shortcode/bkb-shortcodes.php';       
            include_once dirname(__FILE__) . '/shortcode/bkb-tabify-shortcode.php';
            include_once dirname(__FILE__) . '/shortcode/bkb-shortcode-kb-question-submit-form.php';
            include_once dirname(__FILE__) . '/includes/bkb-vote-counter.php';  
            include_once dirname(__FILE__) . '/includes/bkb-custom-theme.php';
           include_once dirname(__FILE__) . '/includes/custom-tax-class/bkb-custom-taxnomy.php'; 
           include_once dirname(__FILE__) . '/includes/custom-tax-class/bkb-tax-custom-column.php'; 

           // Custom KB Sorting.
           // @Since: version 1.1.2
           // @Date: 21-03-16

           include_once dirname(__FILE__) . '/includes/bkb-sorting/bkb_sorting.php'; 

            if( is_admin() ) {

                // we removed CMB from version 1.1.2

                include_once dirname(__FILE__) . '/includes/bkb-custom-column.php';  
                include_once dirname(__FILE__) . '/includes/bkb-custom-meta-box.php';
                include_once dirname(__FILE__) . '/includes/bkb-quick-edit.php';
                include_once dirname(__FILE__) . '/includes/bkb-admin-column-filter.php'; 
                include_once dirname(__FILE__) . '/tinymce/bkb-tiny-mce-config.php';
                include_once dirname(__FILE__) . '/option-panel/plugin-option-panel-menu.php';  
                include_once dirname(__FILE__) . '/option-panel/plugin-option-panel-settings.php';
                include_once dirname(__FILE__) . '/option-panel/bkb-addon-settings.php';

            }

        }


        // @Description: Plugin new version update notification.
        // @Since: version 1.0.1

        public function bkb_cau(){

            global $bkb_data;

            if( isset( $bkb_data['bkb_auto_update_status'] ) && $bkb_data['bkb_auto_update_status'] == 1 && is_admin()) {

               include_once dirname(__FILE__) . '/includes/bkb-update-notifier.php'; 

            }


        }

        // @Description: Load Plugin Front-end Required Custom JS & CSS Files.
        // @Since: version 1.0.0

        function enqueue_plugin_scripts(){

            global $bkb_data;

            if ( ! is_admin()) {

                // Register Accordion Style.
                wp_register_style('bkb-accordion-styles', plugins_url('css/smk-accordion.css', __FILE__), array(), BWL_KB_PLUGIN_VERSION);

                /*------------------------------ Add Custom Styles ---------------------------------*/

                if( ! isset( $bkb_data['bkb_fontawesome_status'] ) || $bkb_data['bkb_fontawesome_status'] == 1 ) {
                    wp_enqueue_style( 'bkb-font-awesome-styles' , plugins_url( 'css/font-awesome.min.css' , __FILE__ ), array(), BWL_KB_PLUGIN_VERSION );
                }

                $bkbm_custom_styles_url = plugins_url('css/bkbm-custom-styles.css', __FILE__);
                $bkbm_rtl_styles_url = plugins_url('css/bkbm-rtl-styles.css', __FILE__);

                // Register Custom Styles For KB Plugin.
                wp_register_style( 'bkbm-custom-styles', $bkbm_custom_styles_url, array(), BWL_KB_PLUGIN_VERSION );
                wp_register_style( 'bkbm-rtl-styles', $bkbm_rtl_styles_url, array(), BWL_KB_PLUGIN_VERSION );
                
                // Load Plugin Custom Style.
                // Fixed in version 1.1.2
                
                wp_enqueue_style('bkbm-custom-styles');

                if (isset($bkb_data['bkb_rtrl_support']) && $bkb_data['bkb_rtrl_support'] == 1) {
                    wp_enqueue_style('bkbm-rtl-styles');
                }

                /*----------------------------- Add Custom JavaScripts ----------------------------------*/

                wp_register_script( 'bkb-accordion-script', plugins_url( 'js/smk-accordion.min.js' , __FILE__ ) , array( 'jquery', 'bkb-custom-script'), BWL_KB_PLUGIN_VERSION, TRUE );
                wp_register_script( 'bkb-remodal-script', plugins_url( 'js/jquery.remodal.js' , __FILE__ ) , array( 'jquery','bkb-custom-script'), BWL_KB_PLUGIN_VERSION, TRUE );
                wp_register_script( 'bkb-tipsy-script', plugins_url( 'js/jquery.tipsy.js' , __FILE__ ) , array( 'jquery', 'bkb-custom-script'), BWL_KB_PLUGIN_VERSION, TRUE );
                wp_register_script( 'bkb-custom-search-script', plugins_url( 'js/custom-search-scripts.js' , __FILE__ ) , array( 'jquery', 'bkb-custom-script'), BWL_KB_PLUGIN_VERSION, TRUE );
                wp_register_script( 'bkb-tabify-script', plugins_url( 'js/bkb-tabify.js' , __FILE__ ) , array( 'jquery', 'bkb-custom-script'), BWL_KB_PLUGIN_VERSION, TRUE );
                wp_register_script( 'bkb-ques-form-script', plugins_url( 'js/bkb-ques-form-script.js' , __FILE__ ) , array( 'jquery', 'bkb-custom-script'), BWL_KB_PLUGIN_VERSION, TRUE );
                wp_register_script( 'bkb-custom-script', plugins_url( 'js/bkb-custom.js' , __FILE__ ) , array( 'jquery'), BWL_KB_PLUGIN_VERSION, TRUE );

            }

        }

        // @Description: Load Plugin Admin Panel Required Custom JS & CSS Files.
        // @Since: version 1.0.0

        function bkbm_admin_load_scripts( $hook ) {

            // Check point To Load JS & CSS files in admin.
            // We only load Plugin required JS & CSS files where it acutally required.

           $bkb_post_type = "";

            if (isset( $_GET['post_type'] ) && $_GET['post_type'] == "bwl_kb") {

                $bkb_post_type = "bwl_kb";


            } else if ( isset($_GET['post'] ) && get_post_type( $_GET['post'] ) === 'bwl_kb' ) {

                 $bkb_post_type = "bwl_kb";

             } else {

                  $bkb_post_type = "";
             }

             // End of checking.


            // Load Font-Awesome only in KB Pages.

            if ( $bkb_post_type == "bwl_kb" ) {

                wp_enqueue_style('bkb-admin-font-awesome-styles', plugins_url('css/font-awesome.min.css', __FILE__), array(), BWL_KB_PLUGIN_VERSION);

            }

            // Load sorting style only in KB pages.

            if( $hook == 'bwl_kb_page_bkb_sort' ) {

                wp_enqueue_style('bkb-sort-styles', plugins_url('css/bkbm-sort.css', __FILE__), array(), BWL_KB_PLUGIN_VERSION);

            }

            // Required JS & CSS Files For KB Shortcode Button.

            wp_register_style('bkb-shortcode-editor-multiple-select-style', plugins_url('tinymce/css/multiple-select.css', __FILE__));
            wp_register_style('bkb-shortcode-editor-style', plugins_url('tinymce/css/bkb-shortcode-editor-style.css', __FILE__));
            wp_register_script('bkb-admin-mutiple-select-script', plugins_url('tinymce/js/jquery.multiple.select.js', __FILE__), array('jquery', 'jquery-ui-core', 'jquery-ui-sortable', 'jquery-ui-draggable', 'jquery-ui-droppable'), '', TRUE);

            // Load Admin Custom Script only in KB pages.

            if ( 'edit.php' == $hook && isset($_GET['post_type']) && $_GET['post_type'] == "bwl_kb" ) {

                wp_register_script('bkb-admin-script', plugins_url('js/bkb-admin-custom.js', __FILE__), array('jquery','jquery-ui-core'), '', TRUE);
                wp_enqueue_script('bkb-admin-script');

            }

            // Load live Font Awesome icon changes only in KB pages.

            if ( $bkb_post_type == "bwl_kb" ) {

                wp_register_script('bkb-fa-live', plugins_url('js/bkb-fa-live.js', __FILE__), array('jquery'), BWL_KB_PLUGIN_VERSION, TRUE);
                wp_enqueue_script('bkb-fa-live');

            }

        }


        // @Description: Define & Register Custom Post Type For Plugin.
        // @Since: version 1.0.0

        public function register_post_type() {

            /*
             * Custom Slug Section.
             * @Since: version 1.0.0
             */        

            global $bkb_data;

            // Default custom slug for knowledgebase plugin. 
            // Admin can change this slug value from option panel. 
            // You need to save the parmalink settings after change the slug value. Other wise you will get 404.
            // To solve this, Go to WP admin panel>settings>Permalinks and click save changes button.

            $bkb_custom_slug = "bwl-knowledge-base"; 

            if( isset($bkb_data['bkb_custom_slug']) && $bkb_data['bkb_custom_slug'] != "" ) {

                $bkb_custom_slug = trim( $bkb_data['bkb_custom_slug'] );

            }

            define("BKB_CUSTOM_SLUG", $bkb_custom_slug);

            $labels = array(
                'name'                         => __('All Knowledge Base', 'bwl-kb'),
                'singular_name'            => __('Knowledge Base', 'bwl-kb'),
                'add_new'                    => __('Add New KB', 'bwl-kb'),
                'add_new_item'           => __('Add New KB', 'bwl-kb'),
                'edit_item'                   => __('Edit KB', 'bwl-kb'),
                'new_item'                  => __('New KB', 'bwl-kb'),
                'all_items'                    => __('All KB Items', 'bwl-kb'),
                'view_item'                  => __('View KB Items', 'bwl-kb'),
                'search_items'             => __('Search KB Items', 'bwl-kb'),
                'not_found'                  => __('No KB found', 'bwl-kb'),
                'not_found_in_trash'    => __('No KB found in Trash', 'bwl-kb'),
                'parent_item_colon'     => '',
                'menu_name'              => __('BWL KB', 'bwl-kb')
            );

            // Default form items supports for Knowledge base plugin.
            // Revisions introduced in version 1.1.2

            $bkb_supports = array('title', 'editor','revisions');


            // Comment section added in version 1.0.6
            // Admin can show/hide comment permssion from plugin option panel.

            if( isset($bkb_data['bkb_comment_status']) && $bkb_data['bkb_comment_status'] == 1 ) {

                $bkb_supports[] = 'comments';

            }

            // KB Thumbnail feature only available with "KB Display As Blog Post" Addon.
            // Download it from: http://codecanyon.net/item/kb-display-as-blog-post-knowledge-base-addon/11245275

            if( function_exists('bkb_kbdabp_compatibily_status') && bkb_kbdabp_compatibily_status() == 1 ) {

                $bkb_supports[] = 'thumbnail';

            }


            $args = array(
                'labels'                       => $labels,
                'query_var'                => 'bwl_kb',    
                'show_in_nav_menus' => true,
                'public'                       => true,        
                'show_ui'                   => true,
                'show_in_menu'         => true,
                'rewrite'                     => array(
                                                     'slug' => $bkb_custom_slug 
                                                   ),
                'publicly_queryable'     => true,
                'capability_type'          => 'post',
                'has_archive'              => FALSE,
                'hierarchical'               => true, // If you need sub category turn it true
                'show_in_admin_bar'  => true,
                'supports'                   => $bkb_supports,
                'menu_icon'                => BWL_KB_PLUGIN_DIR . 'images/bwl_kb_menu_icon.png'
            );        


            register_post_type('bwl_kb', $args); // text domian limitations :D

        }

        // @Description: Register Plugin Required Taxonomies.
        // @Since: Version 1.0.0

        public function taxonomies() {

            /*
             * Custom Slug Section.
             */        

            global $bkb_data;

            $bkb_custom_slug = "bwl-knowledge-base";

            if( isset($bkb_data['bkb_custom_slug']) && $bkb_data['bkb_custom_slug'] != "" ) {

                $bkb_custom_slug = trim( $bkb_data['bkb_custom_slug'] );

            }

            $taxonomies = array();

            $taxonomies['bkb_category'] = array(
                'hierarchical'      => true,
                'query_var'       => 'bkb_category',
                'rewrite'            => array(
                                            'slug' => $bkb_custom_slug. '-category'
                                            ),            
                'labels'              => array(
                                                'name' => __('KB Category', 'bwl-kb'),
                                                'singular_name' => __('Category', 'bwl-kb'),
                                                'edit_item' => __('Edit Category', 'bwl-kb'),
                                                'update_item' =>__('Update category', 'bwl-kb'),
                                                'add_new_item' => __('Add Category', 'bwl-kb'),
                                                'new_item_name' => __('Add New category', 'bwl-kb'),
                                                'all_items' => __('All categories', 'bwl-kb'),
                                                'search_items' => __('Search categories', 'bwl-kb'),
                                                'popular_items' => __('Popular categories', 'bwl-kb'),
                                                'separate_items_with_comments' => __('Separate categories with commas', 'bwl-kb'),
                                                'add_or_remove_items' => __('Add or remove category', 'bwl-kb'),
                                                'choose_from_most_used' => __('Choose from most used categories', 'bwl-kb')
                                            )

             );     

            //  INTRODUCED CATEGORY FILTERING IN ADMIN PANEL FROM VESTION 1.4.8 VERSION

            if(is_admin()) {
                $taxonomies['bkb_category']['query_var'] = TRUE;
            }

            $taxonomies['bkb_tags'] = array(
                'hierarchical'      => true,
                'query_var'       => 'bkb_tags',            
                'rewrite'            => array(
                                                    'slug' => $bkb_custom_slug. '-tags'
                                                ),            
                'labels'              => array(
                                                    'name'                                         => __('KB Tags', 'bwl-kb'),
                                                    'singular_name'                            => __('Tags', 'bwl-kb'),
                                                    'edit_item'                                    => __('Edit Tags', 'bwl-kb'),
                                                    'update_item'                               => __('Update Tags', 'bwl-kb'),
                                                    'add_new_item'                            => __('Add Tag', 'bwl-kb'),
                                                    'new_item_name'                         => __('Add New Tag', 'bwl-kb'),
                                                    'all_items'                                     => __('All Tags', 'bwl-kb'),
                                                    'search_items'                              => __('Search Tags', 'bwl-kb'),
                                                    'popular_items'                             => __('Popular Tags', 'bwl-kb'),
                                                    'separate_items_with_comments' => __('Separate Tags with commas', 'bwl-kb'),
                                                    'add_or_remove_items'                => __('Add or remove Tags', 'bwl-kb'),
                                                    'choose_from_most_used'            => __('Choose from most used Tags', 'bwl-kb')
                                              )

            );

            if(is_admin()) {
                $taxonomies['bkb_tags']['query_var'] = TRUE;
            }

            $this->register_all_taxonomies($taxonomies);

        } 


        function register_all_taxonomies($taxonomies) {

            foreach ($taxonomies as $name=> $arr) {
                register_taxonomy($name, array('bwl_kb'), $arr);
            }

        }

        // Addon Support Filter.
        // Templify KB: http://codecanyon.net/item/templify-kb-knowledge-base-addon/11888104
        // Restriction KB: http://codecanyon.net/item/restrict-kb-access-by-user-role-addon/13722991

        function bkbm_taxonomy_filters($query) {

            global $bkb_data;

            if ( !is_admin() && is_tax('bkb_category') && isset( $bkb_data ['bkb_cat_default_tpl_ordering_status']['enabled']) && $bkb_data['bkb_cat_default_tpl_ordering_status']['enabled'] == 'on' && $query->is_main_query() ) {

                $bkb_cat_default_tpl_order_by = 'date';

                if ( isset( $bkb_data ['bkb_cat_default_tpl_ordering_status']['bkb_cat_default_tpl_order_by']) ){
                    $bkb_cat_default_tpl_order_by = $bkb_data ['bkb_cat_default_tpl_ordering_status']['bkb_cat_default_tpl_order_by'];
                }

                $bkb_cat_default_tpl_order = 'DESC';

                if ( isset( $bkb_data ['bkb_cat_default_tpl_ordering_status']['bkb_cat_default_tpl_order']) ){
                    $bkb_cat_default_tpl_order = $bkb_data ['bkb_cat_default_tpl_ordering_status']['bkb_cat_default_tpl_order'];
                }

                /*------------------------------ Restriction Addon Manager ---------------------------------*/
                if ( function_exists('bkb_rkb_compatibily_status') && bkb_rkb_compatibily_status() == 1 ) {

    //             if ( ( in_array('restrict-kb-by-user-role/restrict-kb-by-user-role.php', apply_filters('active_plugins', get_option('active_plugins')))  && class_exists('BKB_rkb') )) {

                    $query->set( 'post__not_in', bkb_rkb_get_excluded_posts() );

                }

                /*------------------------------ End Restriction Manager ---------------------------------*/

                $query->set('orderby', $bkb_cat_default_tpl_order_by);
                $query->set('order', $bkb_cat_default_tpl_order);

                return $query;

            } else if ( !is_admin() && is_tax('bkb_tags') && isset( $bkb_data ['bkb_tag_default_tpl_ordering_status']['enabled']) && $bkb_data['bkb_tag_default_tpl_ordering_status']['enabled'] == 'on' && $query->is_main_query() ) {

                $bkb_tag_default_tpl_order_by = 'date';

                if ( isset( $bkb_data ['bkb_tag_default_tpl_ordering_status']['bkb_tag_default_tpl_order_by']) ){
                    $bkb_tag_default_tpl_order_by = $bkb_data ['bkb_tag_default_tpl_ordering_status']['bkb_tag_default_tpl_order_by'];
                }

                $bkb_tag_default_tpl_order = 'DESC';

                if ( isset( $bkb_data ['bkb_tag_default_tpl_ordering_status']['bkb_tag_default_tpl_order']) ){
                    $bkb_tag_default_tpl_order = $bkb_data ['bkb_tag_default_tpl_ordering_status']['bkb_tag_default_tpl_order'];
                }

                 /*------------------------------ Restriction Addon Manager ---------------------------------*/
                if ( function_exists('bkb_rkb_compatibily_status') && bkb_rkb_compatibily_status() == 1 ) {
    //            if ( ( in_array('restrict-kb-by-user-role/restrict-kb-by-user-role.php', apply_filters('active_plugins', get_option('active_plugins')))  && class_exists('BKB_rkb') )) {

                    $query->set( 'post__not_in', bkb_rkb_get_excluded_posts('tags') );

                }

                /*------------------------------ End Restriction Manager ---------------------------------*/

                $query->set('orderby', $bkb_tag_default_tpl_order_by);
                $query->set('order', $bkb_tag_default_tpl_order);

                return $query;

            } else {

                return $query;

            }

        }

    }

    /*------------------------------ Initialization ---------------------------------*/

    function init_bwl_kb_manager() {
        new BWL_KB_Manager();
    }

    add_action('init', 'init_bwl_kb_manager');

    /*------------------------------  TRANSLATION FILE ---------------------------------*/

    load_plugin_textdomain('bwl-kb', FALSE, dirname(plugin_basename(__FILE__)) . '/lang/');


    /*------------------------------ Integrate Widgets ---------------------------------*/

    include_once dirname(__FILE__) . '/widget/bkb-widget.php';  

    include_once dirname(__FILE__) . '/widget/bkb-category-widget.php';  

    include_once dirname(__FILE__) . '/widget/bkb-tags-widget.php';

    include_once dirname(__FILE__) . '/widget/bkb-related-posts-widget.php'; // Introduced in version 1.0.2

}